# SPDX-FileCopyrightText: 2020 Helmholtz Centre for Environmental Research (UFZ)
# SPDX-FileCopyrightText: 2020 Helmholtz-Zentrum Dresden-Rossendorf (HZDR)
#
# SPDX-License-Identifier: Apache-2.0

---
- name: Identify which runners are registered
  ansible.builtin.command: gitlab-runner list
  register: configured_runners
  changed_when: False
  check_mode: no

- name: Register Runner in GitLab
  ansible.builtin.command: >
    gitlab-runner register
    --non-interactive
    --url "{{ gitlab_runner.url }}"
    --registration-token  "{{ gitlab_runner.registration_token }}"
    --description "{{ gitlab_runner.name }}"
    --tag-list "{{ gitlab_runner.tags | default([]) | join(',') }}"
    --run-untagged="{{ gitlab_runner.run_untagged | default(gitlab_runner.tags | default([]) | length == 0) }}"
    --executor "{{ gitlab_runner.executor | default('docker') }}"
    {% for env in gitlab_runner.environment | default([]) %}
    --env "{{ env }}"
    {% endfor%}
    --limit "{{ gitlab_runner.limit | default(0) }}"
    --output-limit "{{ gitlab_runner.output_limit | default(4096) }}"
    --locked="{{ gitlab_runner.locked | default(true) }}"
    {% if gitlab_runner.executor is match("docker.*") %}
    --docker-image "{{ gitlab_runner.docker_image | default('debian:latest') }}"
    --docker-privileged="{{ gitlab_runner.docker_privileged | default(false) }}"
    --docker-tlsverify="{{ gitlab_runner.docker_tls_verify | default(false) }}"
    {% for volume in gitlab_runner.docker_volumes | default([]) %}
    --docker-volumes "{{ volume }}"
    {% endfor %}
    {% endif %}
    {% if gitlab_runner.executor == "docker+machine" %}
    --machine-machine-driver "{{ gitlab_runner.machine_driver }}"
    --machine-machine-name "{{ gitlab_runner.machine_name }}"
    --machine-idle-nodes "{{ gitlab_runner.machine_idle_count | default(0) }}"
    --machine-idle-time "{{ gitlab_runner.machine_idle_time | default(0) }}"
    --machine-max-builds "{{ gitlab_runner.machine_max_builds | default(0) }}"
    --machine-max-growth-rate "{{ gitlab_runner.machine_max_growth_rate | default(0) }}"
    {% for option in gitlab_runner.machine_options %}
    --machine-machine-options "{{ option }}"
    {% endfor %}
    {% endif %}
    {% if (gitlab_runner.cache_type | default("")) == "s3" %}
    --cache-type "{{ gitlab_runner.cache_type }}"
    --cache-s3-server-address "{{ gitlab_runner.cache_server_address }}"
    --cache-s3-access-key "{{ gitlab_runner.cache_access_key }}"
    --cache-s3-secret-key "{{ gitlab_runner.cache_secret_key }}"
    --cache-s3-bucket-name "{{ gitlab_runner.cache_bucket_name }}"
    --cache-s3-insecure "{{ gitlab_runner.cache_insecure | default("false") }}"
    {% endif %}
  when: gitlab_runner.name not in configured_runners.stderr
  no_log: True

...
